<template>
	<div class="box-input select-input">
		<label :for="id"><span v-if="required">*</span>{{ label }}</label>
		<input type="text" :id="id" v-model="search" :class="inputClass" required @focus="opened_dropdown = true" @blur="opened_dropdown = false" autocomplete="off"/>
		<transition name="slide">
			<div class="select-input-box" v-show="isShowDropdown">
				<div class="select-input-item" v-for="user in users" @click="selectUser(user)">{{ user.login }}</div>
			</div>
		</transition>
		<input type="hidden" v-model="user_id">
	</div>
</template>

<script>
import {mapGetters} from "vuex";
import _ from 'lodash';

export default {
    name: "SearchUser",
    props: {
        label: String,
        required: Boolean,
        name: String,
        user_id: Number,
		login: String
    },
    data(){
        return {
            id: null,
            search: '',
            users: [],
            opened_dropdown: false,
        }
    },
    watch: {
        search(){
            this.searchUsers();
        }
    },
    computed: {
        ...mapGetters([
            'axios'
        ]),
        isShowDropdown(){
            return Array.isArray(this.users) && this.users.length && this.opened_dropdown;
        },
        inputClass(){
            return {
                'dropdown-is-opened': this.opened_dropdown
            }
        }
    },
    methods: {
        searchUsers(){
            this.axios.get('/users/search', {
                params: {
                    login: this.search,
                    limit: 5
                }
            })
            .then(resp => this.users = resp.data)
            .then(() => this.opened_dropdown = true);
        },
        selectUser(user){
            this.search = user.login;
            this.$emit('change', user.id);
            this.$emit('input', user.id);
			this.opened_dropdown = false;
			setTimeout(() => {
				this.opened_dropdown = false;
			}, 1500);
        }
    },
    created(){
        this.searchUsers = _.debounce(this.searchUsers, 500);
    },
    mounted() {
        this.id = this._uid;
    }
}
</script>

<style scoped lang="scss">
.select-input{
    position: relative;

    .select-input-box{
        position: absolute;
        width: 100%;
        font-family: "Geometria";
        display: block;
        justify-content: flex-start;
        align-items: center;
        border-radius: 27px;
        background-color: #f3f3f3;
        color: #aeaeae;
        font-size: 14px;
        font-weight: 400;
        line-height: 26px;
        outline: none;
        border: none;
        margin: 0;
        overflow: hidden;
        max-height: 300px;

        .select-input-item{
            padding-left: 15px;
            height: 54px;
            line-height: 54px;
        }
        .select-input-item:hover{
            cursor: pointer;
            background: #e3e3e3;
        }
    }
    .select-input{
        input.dropdown-is-opened{
            //border-radius: 27px 27px 0 0 !important;
            //border-bottom: 1px solid #e3e3e3 !important;
        }
    }
}
.slide-enter-active, .slide-leave-active  {
    transition: max-height 0.8s ease;
}
.slide-enter, .slide-leave-to
{
    max-height: 0px !important;
}
</style>
